from enum import Enum

from chli import codes as codes


class BooleanFlag(Enum):
    NO = codes.from_code(codes.boolean.flags, 'HNO')['value']
    YES = codes.from_code(codes.boolean.flags, 'HYES')['value']


class DatabaseAccessMode(Enum):
    READ = codes.from_code(codes.database_access.mode, 'HRMODE')['value']
    CREATE = codes.from_code(codes.database_access.mode, 'HCMODE')['value']
    OVERWRITE = codes.from_code(codes.database_access.mode, 'HOMODE')['value']
    UPDATE = codes.from_code(codes.database_access.mode, 'HUMODE')['value']
    SHARED = codes.from_code(codes.database_access.mode, 'HSMODE')['value']
    WRITE = codes.from_code(codes.database_access.mode, 'HWMODE')['value']
    DIRECT_READ_AND_WRITE = codes.from_code(codes.database_access.mode, 'HDMODE')['value']


class DataObjectBasis(Enum):
    UNDEFINED = codes.from_code(codes.data_object.basis, 'HUNDFX')['value']
    DAILY = codes.from_code(codes.data_object.basis, 'HDAILY')['value']
    BUSINESS = codes.from_code(codes.data_object.basis, 'HBUSNS')['value']


class DataObjectObserved(Enum):
    UNDEFINED = codes.from_code(codes.data_object.observed, 'HOBUND')['value']
    BEGINNING = codes.from_code(codes.data_object.observed, 'HOBBEG')['value']
    ENDING = codes.from_code(codes.data_object.observed, 'HOBEND')['value']
    AVERAGED = codes.from_code(codes.data_object.observed, 'HOBAVG')['value']
    SUMMED = codes.from_code(codes.data_object.observed, 'HOBSUM')['value']
    ANNUALIZED = codes.from_code(codes.data_object.observed, 'HOBANN')['value']
    FORMULA = codes.from_code(codes.data_object.observed, 'HOBFRM')['value']
    HIGH = codes.from_code(codes.data_object.observed, 'HOBHI')['value']
    LOW = codes.from_code(codes.data_object.observed, 'HOBLO')['value']


class DataObjectClass(Enum):
    SERIES = codes.from_code(codes.data_object.class_, 'HSERIE')['value']
    SCALAR = codes.from_code(codes.data_object.class_, 'HSCALA')['value']
    FORMULA = codes.from_code(codes.data_object.class_, 'HFRMLA')['value']
    GLNAME = codes.from_code(codes.data_object.class_, 'HGLNAM')['value']
    GLFORMULA = codes.from_code(codes.data_object.class_, 'HGLFOR')['value']


class DataObjectType(Enum):
    UNDEFINED = codes.from_code(codes.data_object.type_, 'HUNDFT')['value']
    NUMERIC = codes.from_code(codes.data_object.type_, 'HNUMRC')['value']
    NAMELIST = codes.from_code(codes.data_object.type_, 'HNAMEL')['value']
    BOOLEAN = codes.from_code(codes.data_object.type_, 'HBOOLN')['value']
    STRING = codes.from_code(codes.data_object.type_, 'HSTRNG')['value']
    PRECISION = codes.from_code(codes.data_object.type_, 'HPRECN')['value']
    DATE = codes.from_code(codes.data_object.type_, 'HDATE')['value']


class Frequency(Enum):
    UNDEFINED = codes.from_code(codes.frequency.codes, 'HUNDFX')['value']
    DAILY = codes.from_code(codes.frequency.codes, 'HDAILY')['value']
    BUSINESS = codes.from_code(codes.frequency.codes, 'HBUSNS')['value']
    WEEKLY_SUNDAY = codes.from_code(codes.frequency.codes, 'HWKSUN')['value']
    WEEKLY_MONDAY = codes.from_code(codes.frequency.codes, 'HWKMON')['value']
    WEEKLY_TUESDAY = codes.from_code(codes.frequency.codes, 'HWKTUE')['value']
    WEEKLY_WEDNESDAY = codes.from_code(codes.frequency.codes, 'HWKWED')['value']
    WEEKLY_THURSDAY = codes.from_code(codes.frequency.codes, 'HWKTHU')['value']
    WEEKLY_FRIDAY = codes.from_code(codes.frequency.codes, 'HWKFRI')['value']
    WEEKLY_SATURDAY = codes.from_code(codes.frequency.codes, 'HWKSAT')['value']
    TENDAY = codes.from_code(codes.frequency.codes, 'HTENDA')['value']
    BIWEEKLY_ASUNDAY = codes.from_code(codes.frequency.codes, 'HWASUN')['value']
    BIWEEKLY_AMONDAY = codes.from_code(codes.frequency.codes, 'HWAMON')['value']
    BIWEEKLY_ATUESDAY = codes.from_code(codes.frequency.codes, 'HWATUE')['value']
    BIWEEKLY_AWEDNESDAY = codes.from_code(codes.frequency.codes, 'HWAWED')['value']
    BIWEEKLY_ATHURSDAY = codes.from_code(codes.frequency.codes, 'HWATHU')['value']
    BIWEEKLY_AFRIDAY = codes.from_code(codes.frequency.codes, 'HWAFRI')['value']
    BIWEEKLY_ASATURDAY = codes.from_code(codes.frequency.codes, 'HWASAT')['value']
    BIWEEKLY_BSUNDAY = codes.from_code(codes.frequency.codes, 'HWBSUN')['value']
    BIWEEKLY_BMONDAY = codes.from_code(codes.frequency.codes, 'HWBMON')['value']
    BIWEEKLY_BTUESDAY = codes.from_code(codes.frequency.codes, 'HWBTUE')['value']
    BIWEEKLY_BWEDNESDAY = codes.from_code(codes.frequency.codes, 'HWBWED')['value']
    BIWEEKLY_BTHURSDAY = codes.from_code(codes.frequency.codes, 'HWBTHU')['value']
    BIWEEKLY_BFRIDAY = codes.from_code(codes.frequency.codes, 'HWBFRI')['value']
    BIWEEKLY_BSATURDAY = codes.from_code(codes.frequency.codes, 'HWBSAT')['value']
    TWICEMONTHLY = codes.from_code(codes.frequency.codes, 'HTWICM')['value']
    MONTHLY = codes.from_code(codes.frequency.codes, 'HMONTH')['value']
    BIMONTHLY_NOVEMBER = codes.from_code(codes.frequency.codes, 'HBMNOV')['value']
    BIMONTHLY_DECEMBER = codes.from_code(codes.frequency.codes, 'HBIMON')['value']
    QUARTERLY_OCTOBER = codes.from_code(codes.frequency.codes, 'HQTOCT')['value']
    QUARTERLY_NOVEMBER = codes.from_code(codes.frequency.codes, 'HQTNOV')['value']
    QUARTERLY_DECEMBER = codes.from_code(codes.frequency.codes, 'HQTDEC')['value']
    ANNUAL_JANUARY = codes.from_code(codes.frequency.codes, 'HANJAN')['value']
    ANNUAL_FEBRUARY = codes.from_code(codes.frequency.codes, 'HANFEB')['value']
    ANNUAL_MARCH = codes.from_code(codes.frequency.codes, 'HANMAR')['value']
    ANNUAL_APRIL = codes.from_code(codes.frequency.codes, 'HANAPR')['value']
    ANNUAL_MAY = codes.from_code(codes.frequency.codes, 'HANMAY')['value']
    ANNUAL_JUNE = codes.from_code(codes.frequency.codes, 'HANJUN')['value']
    ANNUAL_JULY = codes.from_code(codes.frequency.codes, 'HANJUL')['value']
    ANNUAL_AUGUST = codes.from_code(codes.frequency.codes, 'HANAUG')['value']
    ANNUAL_SEPTEMBER = codes.from_code(codes.frequency.codes, 'HANSEP')['value']
    ANNUAL_OCTOBER = codes.from_code(codes.frequency.codes, 'HANOCT')['value']
    ANNUAL_NOVEMBER = codes.from_code(codes.frequency.codes, 'HANNOV')['value']
    ANNUAL_DECEMBER = codes.from_code(codes.frequency.codes, 'HANDEC')['value']
    SEMIANNUAL_JULY = codes.from_code(codes.frequency.codes, 'HSMJUL')['value']
    SEMIANNUAL_AUGUST = codes.from_code(codes.frequency.codes, 'HSMAUG')['value']
    SEMIANNUAL_SEPTEMBER = codes.from_code(codes.frequency.codes, 'HSMSEP')['value']
    SEMIANNUAL_OCTOBER = codes.from_code(codes.frequency.codes, 'HSMOCT')['value']
    SEMIANNUAL_NOVEMBER = codes.from_code(codes.frequency.codes, 'HSMNOV')['value']
    SEMIANNUAL_DECEMBER = codes.from_code(codes.frequency.codes, 'HSMDEC')['value']
    YPP = codes.from_code(codes.frequency.codes, 'HAYPP')['value']
    PPY = codes.from_code(codes.frequency.codes, 'HAPPY')['value']
    SECONDLY = codes.from_code(codes.frequency.codes, 'HSEC')['value']
    MINUTELY = codes.from_code(codes.frequency.codes, 'HMIN')['value']
    HOURLY = codes.from_code(codes.frequency.codes, 'HHOUR')['value']
    MILLISECONDLY = codes.from_code(codes.frequency.codes, 'HMSEC')['value']
    CASE = codes.from_code(codes.frequency.codes, 'HCASEX')['value']
    GENERIC_WEEKLY_PATTERN = codes.from_code(codes.frequency.codes, 'HWEEK_PATTERN')['value']


class Status(Enum):
    HSUCC = codes.from_code(codes.status.codes, 'HSUCC')['value']
    HINITD = codes.from_code(codes.status.codes, 'HINITD')['value']
    HNINIT = codes.from_code(codes.status.codes, 'HNINIT')['value']
    HFIN = codes.from_code(codes.status.codes, 'HFIN')['value']
    HBFILE = codes.from_code(codes.status.codes, 'HBFILE')['value']
    HBMODE = codes.from_code(codes.status.codes, 'HBMODE')['value']
    HBKEY = codes.from_code(codes.status.codes, 'HBKEY')['value']
    HBSRNG = codes.from_code(codes.status.codes, 'HBSRNG')['value']
    HBERNG = codes.from_code(codes.status.codes, 'HBERNG')['value']
    HBNRNG = codes.from_code(codes.status.codes, 'HBNRNG')['value']
    HNOOBJ = codes.from_code(codes.status.codes, 'HNOOBJ')['value']
    HBRNG = codes.from_code(codes.status.codes, 'HBRNG')['value']
    HDUTAR = codes.from_code(codes.status.codes, 'HDUTAR')['value']
    HBOBJT = codes.from_code(codes.status.codes, 'HBOBJT')['value']
    HBFREQ = codes.from_code(codes.status.codes, 'HBFREQ')['value']
    HTRUNC = codes.from_code(codes.status.codes, 'HTRUNC')['value']
    HNPOST = codes.from_code(codes.status.codes, 'HNPOST')['value']
    HFUSE = codes.from_code(codes.status.codes, 'HFUSE')['value']
    HNFMDB = codes.from_code(codes.status.codes, 'HNFMDB')['value']
    HRNEXI = codes.from_code(codes.status.codes, 'HRNEXI')['value']
    HCEXI = codes.from_code(codes.status.codes, 'HCEXI')['value']
    HNRESW = codes.from_code(codes.status.codes, 'HNRESW')['value']
    HBCLAS = codes.from_code(codes.status.codes, 'HBCLAS')['value']
    HBOBSV = codes.from_code(codes.status.codes, 'HBOBSV')['value']
    HBBASI = codes.from_code(codes.status.codes, 'HBBASI')['value']
    HOEXI = codes.from_code(codes.status.codes, 'HOEXI')['value']
    HBMONT = codes.from_code(codes.status.codes, 'HBMONT')['value']
    HBFLAB = codes.from_code(codes.status.codes, 'HBFLAB')['value']
    HBMISS = codes.from_code(codes.status.codes, 'HBMISS')['value']
    HBINDX = codes.from_code(codes.status.codes, 'HBINDX')['value']
    HNWILD = codes.from_code(codes.status.codes, 'HNWILD')['value']
    HBNCHR = codes.from_code(codes.status.codes, 'HBNCHR')['value']
    HBGROW = codes.from_code(codes.status.codes, 'HBGROW')['value']
    HQUOTA = codes.from_code(codes.status.codes, 'HQUOTA')['value']
    HOLDDB = codes.from_code(codes.status.codes, 'HOLDDB')['value']
    HMPOST = codes.from_code(codes.status.codes, 'HMPOST')['value']
    HSPCDB = codes.from_code(codes.status.codes, 'HSPCDB')['value']
    HBFLAG = codes.from_code(codes.status.codes, 'HBFLAG')['value']
    HPACK = codes.from_code(codes.status.codes, 'HPACK')['value']
    HNEMPT = codes.from_code(codes.status.codes, 'HNEMPT')['value']
    HBATTR = codes.from_code(codes.status.codes, 'HBATTR')['value']
    HDUP = codes.from_code(codes.status.codes, 'HDUP')['value']
    HBYEAR = codes.from_code(codes.status.codes, 'HBYEAR')['value']
    HBPER = codes.from_code(codes.status.codes, 'HBPER')['value']
    HBDAY = codes.from_code(codes.status.codes, 'HBDAY')['value']
    HBDATE = codes.from_code(codes.status.codes, 'HBDATE')['value']
    HBSEL = codes.from_code(codes.status.codes, 'HBSEL')['value']
    HBREL = codes.from_code(codes.status.codes, 'HBREL')['value']
    HBTIME = codes.from_code(codes.status.codes, 'HBTIME')['value']
    HBCPU = codes.from_code(codes.status.codes, 'HBCPU')['value']
    HEXPIR = codes.from_code(codes.status.codes, 'HEXPIR')['value']
    HBPROD = codes.from_code(codes.status.codes, 'HBPROD')['value']
    HBUNIT = codes.from_code(codes.status.codes, 'HBUNIT')['value']
    HBCNTX = codes.from_code(codes.status.codes, 'HBCNTX')['value']
    HLOCKD = codes.from_code(codes.status.codes, 'HLOCKD')['value']
    HNETCN = codes.from_code(codes.status.codes, 'HNETCN')['value']
    HNFAME = codes.from_code(codes.status.codes, 'HNFAME')['value']
    HNBACK = codes.from_code(codes.status.codes, 'HNBACK')['value']
    HSUSPN = codes.from_code(codes.status.codes, 'HSUSPN')['value']
    HBSRVR = codes.from_code(codes.status.codes, 'HBSRVR')['value']
    HCLNLM = codes.from_code(codes.status.codes, 'HCLNLM')['value']
    HBUSER = codes.from_code(codes.status.codes, 'HBUSER')['value']
    HSRVST = codes.from_code(codes.status.codes, 'HSRVST')['value']
    HBOPT = codes.from_code(codes.status.codes, 'HBOPT')['value']
    HBOPTV = codes.from_code(codes.status.codes, 'HBOPTV')['value']
    HNSUPP = codes.from_code(codes.status.codes, 'HNSUPP')['value']
    HBLEN = codes.from_code(codes.status.codes, 'HBLEN')['value']
    HNULLP = codes.from_code(codes.status.codes, 'HNULLP')['value']
    HNWFEA = codes.from_code(codes.status.codes, 'HNWFEA')['value']
    HBGLNM = codes.from_code(codes.status.codes, 'HBGLNM')['value']
    HCLCHN = codes.from_code(codes.status.codes, 'HCLCHN')['value']
    HDPRMC = codes.from_code(codes.status.codes, 'HDPRMC')['value']
    HWKOPN = codes.from_code(codes.status.codes, 'HWKOPN')['value']
    HNOMEM = codes.from_code(codes.status.codes, 'HNOMEM')['value']
    HBFUNC = codes.from_code(codes.status.codes, 'HBFUNC')['value']
    HUNEXP = codes.from_code(codes.status.codes, 'HUNEXP')['value']
    HBVER = codes.from_code(codes.status.codes, 'HBVER')['value']
    HNFILE = codes.from_code(codes.status.codes, 'HNFILE')['value']
    HMFILE = codes.from_code(codes.status.codes, 'HMFILE')['value']
    HSCLLM = codes.from_code(codes.status.codes, 'HSCLLM')['value']
    HDBCLM = codes.from_code(codes.status.codes, 'HDBCLM')['value']
    HSNFIL = codes.from_code(codes.status.codes, 'HSNFIL')['value']
    HSMFIL = codes.from_code(codes.status.codes, 'HSMFIL')['value']
    HRESFD = codes.from_code(codes.status.codes, 'HRESFD')['value']
    HTMOUT = codes.from_code(codes.status.codes, 'HTMOUT')['value']
    HCHGAC = codes.from_code(codes.status.codes, 'HCHGAC')['value']
    HFMENV = codes.from_code(codes.status.codes, 'HFMENV')['value']
    HLICFL = codes.from_code(codes.status.codes, 'HLICFL')['value']
    HLICNS = codes.from_code(codes.status.codes, 'HLICNS')['value']
    HRMTDB = codes.from_code(codes.status.codes, 'HRMTDB')['value']
    HBCONN = codes.from_code(codes.status.codes, 'HBCONN')['value']
    HABORT = codes.from_code(codes.status.codes, 'HABORT')['value']
    HNCONN = codes.from_code(codes.status.codes, 'HNCONN')['value']
    HNMCA = codes.from_code(codes.status.codes, 'HNMCA')['value']
    HBATYP = codes.from_code(codes.status.codes, 'HBATYP')['value']
    HBASRT = codes.from_code(codes.status.codes, 'HBASRT')['value']
    HBPRSP = codes.from_code(codes.status.codes, 'HBPRSP')['value']
    HBGRP = codes.from_code(codes.status.codes, 'HBGRP')['value']
    HNLOCL = codes.from_code(codes.status.codes, 'HNLOCL')['value']
    HDHOST = codes.from_code(codes.status.codes, 'HDHOST')['value']
    HOPENW = codes.from_code(codes.status.codes, 'HOPENW')['value']
    HOPEND = codes.from_code(codes.status.codes, 'HOPEND')['value']
    HNTWIC = codes.from_code(codes.status.codes, 'HNTWIC')['value']
    HPWWOU = codes.from_code(codes.status.codes, 'HPWWOU')['value']
    HMAXDB = codes.from_code(codes.status.codes, 'HMAXDB')['value']
    HREMSUP = codes.from_code(codes.status.codes, 'HREMSUP')['value']
    HBADVAL = codes.from_code(codes.status.codes, 'HBADVAL')['value']
    HNOMAP = codes.from_code(codes.status.codes, 'HNOMAP')['value']
    HROSCONN = codes.from_code(codes.status.codes, 'HROSCONN')['value']
    HRKEYINV = codes.from_code(codes.status.codes, 'HRKEYINV')['value']
    HRUSERINV = codes.from_code(codes.status.codes, 'HRUSERINV')['value']
    HROSTRANS = codes.from_code(codes.status.codes, 'HROSTRANS')['value']
    HRDISTRANS = codes.from_code(codes.status.codes, 'HRDISTRANS')['value']
    HRHANDINV = codes.from_code(codes.status.codes, 'HRHANDINV')['value']
    HNSUPDB = codes.from_code(codes.status.codes, 'HNSUPDB')['value']
    HCVTDB = codes.from_code(codes.status.codes, 'HCVTDB')['value']
    HOBSFUNC = codes.from_code(codes.status.codes, 'HOBSFUNC')['value']
    HBV3TYPE = codes.from_code(codes.status.codes, 'HBV3TYPE')['value']
    HBV3RANGE = codes.from_code(codes.status.codes, 'HBV3RANGE')['value']
    HBV3DATE = codes.from_code(codes.status.codes, 'HBV3DATE')['value']
    HNTOOLONG = codes.from_code(codes.status.codes, 'HNTOOLONG')['value']
    HUTOOLONG = codes.from_code(codes.status.codes, 'HUTOOLONG')['value']
    HFUTURE_TYPE = codes.from_code(codes.status.codes, 'HFUTURE_TYPE')['value']
    HBTYPE = codes.from_code(codes.status.codes, 'HBTYPE')['value']
    HOBJSIZE = codes.from_code(codes.status.codes, 'HOBJSIZE')['value']
    HUSRPWTOOLONG = codes.from_code(codes.status.codes, 'HUSRPWTOOLONG')['value']
    HNFSRCLONG = codes.from_code(codes.status.codes, 'HNFSRCLONG')['value']
    HFRMSYNTAXERR = codes.from_code(codes.status.codes, 'HFRMSYNTAXERR')['value']
    HNOFORMV3 = codes.from_code(codes.status.codes, 'HNOFORMV3')['value']
    HIFAIL = codes.from_code(codes.status.codes, 'HIFAIL')['value']
    HFAMER = codes.from_code(codes.status.codes, 'HFAMER')['value']
